unit Unit1;

interface

uses
  Windows, Registry, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, RXShell, ExtCtrls, ToolWin, ComCtrls, Psock, NMpop3,
  Buttons, shellapi, mmsystem;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    RxTrayIcon1: TRxTrayIcon;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    NMPOP31: TNMPOP3;
    ListBox1: TListBox;
    PopupMenu2: TPopupMenu;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    CheckBox1: TCheckBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    OpenDialog1: TOpenDialog;
    N9: TMenuItem;
    procedure log(Msg:string);
    procedure GotMessage(Msg:string);
    procedure WMEndSession(var Msg:TWMEndSession);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RxTrayIcon1DblClick(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure N9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ApplicationMinimize(Sender : TObject);
    procedure ApplicationRestore(Sender : TObject);
  end;

var
  Form1: TForm1;
  logfile,launch,sound:string;
  mesage:boolean;
  F,Log : TextFile;
implementation

uses Unit2, Unit3;

{$R *.DFM}
{$REALCOMPATIBILITY ON}

Function Checkmail(Host:string;UserID:string;Password:string):boolean;
begin
  result:=false;
  try
    form1.nmpop31.Host := Host;
    form1.nmpop31.UserID := UserID;
    form1.nmpop31.Password := Password;
    form1.nmpop31.Connect;
    form1.log('Connecting with '+form1.nmpop31.host);
    if form1.nmpop31.MailCount >0 then result:=true;
    form1.log(inttostr(form1.nmpop31.MailCount)+' messages on server');
    form1.nmpop31.Disconnect;
    form1.log('Disconnect');
  except
    form1.log('Connection failed');
  end;
end;

procedure TForm1.log(Msg:string);
var
  l:textfile;
begin
  if logfile ='' then exit;
  assignfile(l,logfile);
  append(l);
  writeln(l,msg);
  closefile(l);
end;

procedure TForm1.GotMessage(Msg:string);
begin
  log('Need to inform user about new messages on '+msg);
  PlaySound(pchar(sound),1,snd_async);
  ShellExecute(Application.Handle, 'open', pchar(launch),nil,nil,0);
  if mesage then Showmessage('You have mail on '+msg);
  application.BringToFront;
end;

procedure TForm1.WMEndSession(var Msg: TWMEndSession);
begin
  form1.Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  temp:string;
  l:textfile;
begin
  application.OnMinimize := form1.ApplicationMinimize;
  application.OnRestore := form1.ApplicationRestore;
  try
    AssignFile(F,extractfilepath(application.exename)+'mailcheck.ini');
    Reset(F);
    Readln(F,temp);
    Readln(F,temp);
    timer1.Interval := strtoint(temp);
    Readln(F,temp);
    launch := temp;
    Readln(F,temp);
    sound := temp;
    Readln(F,temp);
    logfile := temp;
    Readln(F,temp);
    mesage:=false;
    if temp<>'' then mesage:=true;
    while not eof(f) do
    begin
      Readln(F,temp);
      listbox1.items.add(temp)
    end;
  except
    timer1.Interval := 60000;
    launch := '';
    sound := '';
    logfile := extractfilepath(application.exename)+'log.txt';
    mesage:=false;
  end;
  closefile(f);

  edit1.text:=floattostr(timer1.interval/60000);
  edit2.text:=launch;
  edit3.text:=sound;
  edit4.text:=logfile;
  checkbox1.Checked := mesage;

  if logfile='' then exit;
  assignfile(l,logfile);
  rewrite(l);
  writeln(l,'Program launch');
  closefile(l);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i:integer;
begin
  AssignFile(F,extractfilepath(application.exename)+'MailCheck.ini');
  Rewrite(F);
  Writeln(F,'Inifile for MailCheck');
  Writeln(F,timer1.interval);
  Writeln(F,launch);
  Writeln(F,sound);
  Writeln(F,logfile);
  if mesage then Writeln(F,'Yes') else Writeln(F,'');

  for i:=0 to listbox1.Items.Count-1 do
    writeln(f,listbox1.items[i]);

  CloseFile(F);

  log('Exit program');
end;

procedure TForm1.RxTrayIcon1DblClick(Sender: TObject);
begin
Application.Restore;
form1.WindowState := wsNormal;
form1.Show;
Application.BringToFront;
RxTrayIcon1.Active := false;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  application.Minimize;
end;

procedure TForm1.N4Click(Sender: TObject);
begin
form1.Close;
application.Terminate;
end;

procedure TForm1.N1Click(Sender: TObject);
begin
Application.Restore;
Application.BringToFront;
RxTrayIcon1.Active := false;
end;

procedure TForm1.N5Click(Sender: TObject);
begin
  form3.show;
end;

procedure TForm1.N6Click(Sender: TObject);
var
  n,h,l,p:string;
begin
  timer1.enabled:=false;
  if not inputquery('  ','  ',n) then exit;
  if not inputquery('  ','  ',h) then exit;
  if not inputquery('  ',' ',l) then exit;
  if not inputquery('  ',' ',p) then exit;
  try
    AssignFile(F,extractfilepath(application.exename)+n+'.mcd');
    Rewrite(F);
    writeln(f,h);
    writeln(f,l);
    writeln(f,p);
    CloseFile(F);
    listbox1.items.add(n);
  except
    showmessage('Unexpected error');
    exit;
  end;
  timer1.enabled:=true;

  log('New POP server: '+n+' on '+h);
end;

procedure TForm1.N7Click(Sender: TObject);
var
  s:string;
begin
  if listbox1.itemindex<0 then exit;
  s:=listbox1.items[listbox1.ItemIndex];
  s:=extractfilepath(application.exename)+s+'.mcd';
  deletefile(s);
  log(s + ' has been deleted');
  listbox1.Items.Delete(listbox1.ItemIndex);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
 i:integer;
 h,l,p:string;
begin
  log(timetostr(time)+' - time to get mail');
  form1.timer1.Enabled := false;
  for i:=0 to form1.listbox1.Items.Count-1 do
  begin
    assignfile(f,extractfilepath(application.exename)+form1.listbox1.items[i]+'.mcd');
    reset(f);
    readln(f,h);
    readln(f,l);
    readln(f,p);
    if checkmail(h,l,p) then gotmessage(form1.listbox1.items[i]);
  end;
  form1.timer1.Enabled := true;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  opendialog1.execute;
  edit2.text:=opendialog1.FileName;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  opendialog1.execute;
  edit3.text:=opendialog1.FileName;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  opendialog1.execute;
  edit4.text:=opendialog1.FileName;
end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
  timer1.Interval := strtoint(edit1.text)*60000;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  launch:=edit2.text;
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
  sound:=edit3.text;
end;

procedure TForm1.Edit4Change(Sender: TObject);
begin
  logfile:=edit4.text;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  mesage:=checkbox1.checked;
end;

procedure TForm1.ApplicationMinimize(Sender : TObject);
begin
ShowWindow(Application.Handle, SW_HIDE);
RxTrayIcon1.Active := true;
end;

procedure TForm1.ApplicationRestore(Sender : TObject);
begin
ShowWindow(Application.Handle, SW_NORMAL);
RxTrayIcon1.Active := true;
end;

procedure TForm1.N8Click(Sender: TObject);
var
  r:textfile;
  h,l,p:string;
begin
  timer1.enabled:=false;

  if listbox1.itemindex<0 then exit;
  assignfile(r,extractfilepath(application.exename)+form1.listbox1.items[listbox1.itemindex]+'.mcd');
  reset(r);
  readln(r,h);
  readln(r,l);
  readln(r,p);
  closefile(r);

  h:=inputbox('  ',' -',h);
  l:=inputbox('  ',' ',l);
  p:=inputbox('  ',' ',p);

  try
    AssignFile(r,extractfilepath(application.exename)+listbox1.items[listbox1.itemindex]+'.mcd');
    Rewrite(r);
    writeln(r,h);
    writeln(r,l);
    writeln(r,p);
    CloseFile(r);
  except
    showmessage('Unexpected error');
    exit;
  end;

  timer1.enabled:=true;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
ShowWindow(Application.Handle, SW_HIDE);
application.Minimize;
end;

procedure TForm1.N9Click(Sender: TObject);
begin
  Form1.Timer1Timer(form1);
end;

end.
